﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FirstExample
{
    class Program
    {
        static void Main( string[] args )
        {
            string[] words = { "hello", "wonderful", "linq", "beautiful", "world" };

            // Prosty przykład
            Console.WriteLine( "1. ----------" );
            var shortWords =
                from word in words
                where word.Length <= 5
                select word;
            foreach ( var word in shortWords )
                Console.WriteLine( word );

            // Prosty przykład -- inne podejście
            Console.WriteLine( "2. ----------" );
            foreach ( var word in words.Where( w => w.Length <= 5 ) )
                Console.WriteLine( word );


            // Mniej prosty przykład
            Console.WriteLine( "3. ----------" );
            var groups1 =
                from word in words
                orderby word ascending
                group word by word.Length into lengthGroups
                orderby lengthGroups.Key descending
                select new { Length = lengthGroups.Key, Words = lengthGroups };
            
            foreach ( var group in groups1 )
            {
                Console.WriteLine( "Words of length " + group.Length );
                foreach ( string word in group.Words )
                    Console.WriteLine( " " + word );
            }
            
            // Mniej prosty przykład -- inne podejście
            Console.WriteLine( "4. ----------" );
            var groups2 = words
                .GroupBy( w => w.Length )
                .OrderByDescending( w => w.Key )
                .Select( w => new { Length = w.Key, Words = w.ToList() } );

            foreach ( var group in groups2 )
            {
                Console.WriteLine( "Words of length " + group.Length );
                foreach ( string word in group.Words )
                    Console.WriteLine( " " + word );
            }

            Console.ReadLine();
        }
    }
}
